using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.CompositeUI;
using Microsoft.Practices.CompositeUI.SmartParts;
using System.Windows.Forms;
using Microsoft.Practices.CompositeUI.EventBroker;

namespace AddressBookModule
{
    public class AddBookModWorkItem : WorkItem
    {        
        IEditor editorView;

        DataCollection infoCollection = new DataCollection();

        public void Run(IWorkspace editorWorkSpace, IWorkspace listWorkSpace)
        {            
            editorView = this.Items.AddNew<AddressBookEditorView>();

            editorView.Load += new EventHandler(editorView_Load);

            AddressBookListView listView = this.Items.AddNew<AddressBookListView>();           
                        
            editorWorkSpace.Show(editorView);
            
            listWorkSpace.Show(listView);
        }

        void editorView_Load(object sender, EventArgs e)
        {
            editorView.NameCollection = this.infoCollection.GetContacts("sp_get_Name", "");
        }        
    }
}
