using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Practices.CompositeUI;
using Microsoft.Practices.CompositeUI.Services;
using System.Windows.Forms;

namespace AddressBookModule
{
    public class AddBookModuleInit : ModuleInit
    {
        private IWorkItemTypeCatalogService catalogService;
        private WorkItem parentWorkItem;

        [ServiceDependency]
        public IWorkItemTypeCatalogService CatalogService
        {
            set { catalogService = value; }
        }

        [ServiceDependency]
        public WorkItem ParentWorkItem
        {
            set { parentWorkItem = value; }
        }

        public override void Load()
        {
            base.Load();           
            AddBookModWorkItem addressWorkItem = parentWorkItem.WorkItems.AddNew<AddBookModWorkItem>();
            addressWorkItem.Run(parentWorkItem.Workspaces["deckWorkspaceEditor"], parentWorkItem.Workspaces["deckWorkspaceList"]);
            catalogService.RegisterWorkItem<AddBookModWorkItem>();            
        }
    }
}
