using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;

namespace AddressBookModule
{
    public class DataCollection
    {
        SqlConnection sqlConnection;
        SqlCommand sqlCommand;
        SqlDataAdapter sqlDataAdapter;


        public void Connect()
        {
            string connectionString = "Data Source=VIJAY-WPF;User ID=sa;Password=sa;Initial Catalog=Northwind";
            sqlConnection = new SqlConnection(connectionString);
            sqlConnection.Open();
        }

        public DataTable GetContacts(string procName, string name)
        {
            sqlCommand = new SqlCommand();
            try
            {
                Connect();
                                
                sqlCommand.Connection = sqlConnection;
                sqlCommand.CommandText = procName;
                sqlCommand.CommandType = CommandType.StoredProcedure;

                if (!string.IsNullOrEmpty(name))
                {
                    sqlCommand.Parameters.AddWithValue("@name", name);
                }

                sqlDataAdapter = new SqlDataAdapter(sqlCommand);

                DataSet dataSet = new DataSet();

                sqlDataAdapter.Fill(dataSet);

                DataTable dataTable = new DataTable();
                dataTable = dataSet.Tables[0];

                return dataTable;
            }
            catch (SqlException excep)
            {
                MessageBox.Show(excep.Message);
                return null;
            }
            finally
            {
                sqlCommand.Dispose();
                if (sqlConnection.State == ConnectionState.Open)
                {
                    sqlConnection.Close();
                }
            }
        }

        public void AddEditContact(string procName, string name, string job, string company, string email,
                       string displayName, string webPage, string business, string home,
                       string mobile, string address, string action)
        {            
            try
            {               
                Connect();

                sqlCommand = new SqlCommand();
                sqlCommand.Connection = sqlConnection;
                sqlCommand.CommandText = procName;
                sqlCommand.CommandType = CommandType.StoredProcedure;

                sqlCommand.Parameters.AddWithValue("@name", name);
                sqlCommand.Parameters.AddWithValue("@job", job);
                sqlCommand.Parameters.AddWithValue("@company", company);
                sqlCommand.Parameters.AddWithValue("@email", email);
                sqlCommand.Parameters.AddWithValue("@displayName", displayName);
                sqlCommand.Parameters.AddWithValue("@webPage", webPage);
                sqlCommand.Parameters.AddWithValue("@business", business);
                sqlCommand.Parameters.AddWithValue("@home", home);
                sqlCommand.Parameters.AddWithValue("@mobile", mobile);
                sqlCommand.Parameters.AddWithValue("@address", address);                

                sqlCommand.ExecuteNonQuery();                
            }
            catch (SqlException excep)
            {
                MessageBox.Show(excep.Message);
            }
            finally
            {
                sqlCommand.Dispose();
                if (sqlConnection.State == ConnectionState.Open) { sqlConnection.Close(); }
            }
        }

        public void DeleteContact(string name)
        {
            sqlCommand = new SqlCommand();
            try
            {
                Connect();

                sqlCommand.Connection = sqlConnection;
                sqlCommand.CommandText = "sp_DeleteContact";
                sqlCommand.CommandType = CommandType.StoredProcedure;

                sqlCommand.Parameters.AddWithValue("@name", name);

                sqlCommand.ExecuteNonQuery();
            }
            catch (SqlException excep)
            {
                MessageBox.Show(excep.Message);
            }
            finally
            {
                sqlCommand.Dispose();
                if (sqlConnection.State == ConnectionState.Open) { sqlConnection.Close(); }
            }
        }

        public bool CheckExists(string name)
        {            
            try
            {
                Connect();
                sqlCommand = new SqlCommand();
                sqlCommand.Connection = sqlConnection;
                sqlCommand.CommandText = "sp_CheckContactExists";
                sqlCommand.CommandType = CommandType.StoredProcedure;

                sqlCommand.Parameters.AddWithValue("@name", name);

                SqlDataReader reader = sqlCommand.ExecuteReader();
                if (reader.Read())
                {
                    return true;
                }
                return false;               
            }
            catch (SqlException excep)
            {
                MessageBox.Show(excep.Message);
                return false;
            }
            finally
            {
                sqlCommand.Dispose();
                if (sqlConnection.State == ConnectionState.Open) { sqlConnection.Close(); }
            }
        }        
    }
}
