using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Microsoft.Practices.CompositeUI;
using Microsoft.Practices.CompositeUI.WinForms;
using Microsoft.Practices.CompositeUI.Commands;
using Microsoft.Practices.CompositeUI.Services;
using Microsoft.Practices.CompositeUI.UIElements;

namespace SampleAddressBook
{
    public class AddressBookApplication : FormShellApplication<AddressBookWorkItem, AddressBookForm>
    {
       [STAThread]
        static void Main()
        {
            new AddressBookApplication().Run();
        }

        protected override void AfterShellCreated()
        {
            base.AfterShellCreated();

            ToolStripMenuItem fileItem = (ToolStripMenuItem)Shell.MainMenuStrip.Items["File"];

            RootWorkItem.UIExtensionSites.RegisterSite("MainMenu", Shell.MainMenuStrip);
           // RootWorkItem.UIExtensionSites.RegisterSite(UIExtensionConstants.MAINSTATUS, Shell.mainStatusStrip);
            RootWorkItem.UIExtensionSites.RegisterSite("File", fileItem);
            RootWorkItem.UIExtensionSites.RegisterSite("FileDropDown", fileItem.DropDownItems);

            ToolStripMenuItem entryItem = (ToolStripMenuItem)Shell.MainMenuStrip.Items["Entry"];

            RootWorkItem.UIExtensionSites.RegisterSite("Entry", entryItem);
            RootWorkItem.UIExtensionSites.RegisterSite("EntryDropDown", entryItem.DropDownItems);
            
            // Load the menu structure from App.config
            UIElementBuilder.LoadFromConfig(RootWorkItem);
        }
    }
}