using System;
using System.Windows.Forms;
using System.Configuration;


namespace SampleAddressBook
{
    class MenuItemElement : ConfigurationElement
    {
        [ConfigurationProperty("site", IsRequired = true)]
        public string Site
        {
            set
            {
                this["site"] = value;
            }
            get
            {
                return (string)this["site"];
            }
        }

        [ConfigurationProperty("commandname", IsRequired = false)]
        public string CommandName
        {
            set
            {
                this["commandname"] = value;
            }
            get
            {
                return (string)this["commandname"];
            }
        }

        [ConfigurationProperty("key", IsRequired = false)]
        public string Key
        {
            set
            {
                this["key"] = value;
            }
            get
            {
                return (string)this["key"];
            }
        }

        [ConfigurationProperty("id", IsRequired = false, IsKey = true)]
        public string Id
        {
            set
            {
                this["key"] = value;
            }
            get
            {
                return (string)this["key"];
            }
        }

        [ConfigurationProperty("label", IsRequired = true)]
        public string Label
        {
            set
            {
                this["label"] = value;
            }
            get
            {
                return (string)this["label"];
            }
        }

        [ConfigurationProperty("register", IsRequired = false)]
        public bool Register
        {
            set
            {
                this["register"] = value;
            }
            get
            {
                return (bool)this["register"];
            }
        }

        [ConfigurationProperty("registrationsite", IsRequired = false)]
        public string RegistrationSite
        {
            set
            {
                this["registrationsite"] = value;
            }
            get
            {
                return (string)this["registrationsite"];
            }
        }

        public ToolStripMenuItem MenuItem()
        {
            ToolStripMenuItem item = new ToolStripMenuItem();
            item.Text = Label;

            if (!string.IsNullOrEmpty(Key))
            {
                item.ShortcutKeys = (Keys)Enum.Parse(typeof(Keys), Key);
            }
            return item;
        }
    }
}
