using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using Microsoft.Practices.CompositeUI;
using Microsoft.Practices.CompositeUI.UIElements;
using Microsoft.Practices.CompositeUI.WinForms;
using System.Windows.Forms;

namespace SampleAddressBook
{
    public static class UIElementBuilder
    {
        public static void LoadFromConfig(WorkItem workItem)
        {
            ShellItemSection section = (ShellItemSection)ConfigurationManager.GetSection("shellitems");

            foreach (MenuItemElement menuItem in section.MenuItems)
            {
                ToolStripMenuItem uiMenuItem = menuItem.MenuItem();

                workItem.UIExtensionSites[menuItem.Site].Add(uiMenuItem);

                if (menuItem.Register == true)
                    workItem.UIExtensionSites.RegisterSite(menuItem.RegistrationSite, uiMenuItem.DropDownItems);

                if (!String.IsNullOrEmpty(menuItem.CommandName))
                    workItem.Commands[menuItem.CommandName].AddInvoker(uiMenuItem, "Click");
            }
        }        
    }
}
